@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@using Microsoft.AspNetCore.Components.Forms
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@implements IDisposable

<Row>
  <Column>
    <Field Horizontal="true">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is8.OnDesktop">@Localize["Hibernations"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is4.OnDesktop">
        <Select TValue="string" @bind-SelectedValue="SD.Filters.HibernationsFilter">
          <SelectItem TValue="string" Value="@("*")">@Localize["All"]</SelectItem>
          <SelectItem TValue="string" Value="@("{0}==0")">0</SelectItem>
          <SelectItem TValue="string" Value="@("{0}==1")">1</SelectItem>
          <SelectItem TValue="string" Value="@("{0}==2")">2</SelectItem>
          <SelectItem TValue="string" Value="@("{0}<=1")">-1</SelectItem>
          <SelectItem TValue="string" Value="@("{0}<=2")">-2</SelectItem>
          <SelectItem TValue="string" Value="@("{0}<=3")">-3</SelectItem>
          <SelectItem TValue="string" Value="@("{0}>=1")">1+</SelectItem>
          <SelectItem TValue="string" Value="@("{0}>=2")">2+</SelectItem>
          <SelectItem TValue="string" Value="@("{0}>=3")">3+</SelectItem>
        </Select>
      </FieldBody>
    </Field>
  </Column>
</Row>

@code {

  protected override void OnInitialized() {
    SD.Filters.FilterChanged += this.FilterChanged;
  }

  private void FilterChanged(object sender, EventArgs e) {
    this.InvokeAsync(() => this.StateHasChanged());
  }

  public void Dispose() {
    SD.Filters.FilterChanged -= this.FilterChanged;
  }
}
